zsh-users
 help / color / mirror / code / Atom feed
From: "René Neumann" <lists@necoro.eu>
To: zsh-users@zsh.org
Subject: Re: local/non-local and sub shell exit codes
Date: Sun, 10 Jun 2018 15:34:04 +0200	[thread overview]
Message-ID: <7f581992-e736-a801-9068-58902cba4953@necoro.eu> (raw)
In-Reply-To: <80a94a63-2862-8ccc-99ca-399dd5def008@necoro.eu>

Ok, I have to take it back. Found the following in the manpage (after
discovering, that 'local' is an alias for 'typeset'):

---8<---
Unlike parameter assignment statements, typeset's exit status on an
assignment that involves a command substitution does not reflect the
exit status of the command substitution. Therefore, to test for an error
in a command substitution, separate the declaration of the parameter
from its initialization:
  # WRONG
  typeset var1=$(exit 1) || echo "Trouble with var1"

  # RIGHT
  typeset var1 && var1=$(exit 1) || echo "Trouble with var1"
--->8---

- René

Am 10.06.2018 um 15:18 schrieb René Neumann:
> Hi all,
> 
> I just encountered this strange behavior under zsh-5.5.1:
> 
> % foo=$(false); echo $?
> 1
> % local foo=$(false); echo $?
> 0
> 
> Is this intended? As I'm pretty sure that this behavior is new...
> 
> Best regards,
> René
> 


  reply	other threads:[~2018-06-10 13:34 UTC|newest]

Thread overview: 3+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-06-10 13:18 René Neumann
2018-06-10 13:34 ` René Neumann [this message]
2018-06-10 13:46   ` dana

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=7f581992-e736-a801-9068-58902cba4953@necoro.eu \
    --to=lists@necoro.eu \
    --cc=zsh-users@zsh.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/zsh/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).